#include	"ksysdefs.h"
#include	"ksysvtyp.h"
#include	"ksysprot.h"
#include	"kroffdef.h"
#include	"kroffvar.h"
#ifndef		ZERO	
#define		ZERO	0
#endif
#ifndef     ONFONT
#define     ONFONT      1
#define     NOFONT      0
#endif
/*EXTERNAL*/
#undef		XASCII
#define		XASCII
#define		A_HAT	0
#define		E_HAT	1
#define		I_HAT	2
#define		O_HAT	3
#define		U_HAT	4
char	*vowel[5];
/**/
#define     xfont(a)((x[nv].pf = x[nv].cf, x[nv].cf = a))
/*
*/
static      char    ws[BLKSIZ];
static      char    *wsu = ws + BLKSIZ -1;
/*
*/
zft(nv,is)
char    *is;
{
	switch(*is) {
	case    'B':    xfont(FOB);
					break;
	case    'I':    xfont(FOI);
					break;
	case    'R':    xfont(FOR);
					break;
	case    'U':    xfont(FOU);
					break;
	default:
	case    'P':    x[nv].cf ^= x[nv].pf;
					x[nv].pf ^= x[nv].cf;
					x[nv].cf ^= x[nv].pf;
					break;
	}
	return(x[nv].cf);
}
xft(nv,is)          /* set font */
char    *is;
{
	return(zft(nv,is));
}
char    *
zesc(nv,is,ty)
char    *is;
{
	auto    char    *ps;
	if(*is == ESC && is[1] == '!')  {
		fputs(is+2,x[nv].ofp);
		putc('\n',x[nv].ofp);
		*is = ZERO;
		return(NULL);
		}
	ps = is;
	zesc0(nv,ws,wsu,is,ty,&ps);
	if(x[nv].ta)                xtab(ws,wsu,is);
	return(is);
}
char    *
zesc0(nv,os,us,is,ty,ps)
char    *os, *us, *is, **ps;
{
	REG     char    *isx = is;
	REG     char    *osx = os;
	REG     char    *usx = us;
	if(ty == ONFONT)    *osx++ = x[nv].cf;
	while(osx < usx && *isx != ZERO)
	if(*isx == ESC) {
/*ESCAPES*/
		osx = zesc1(nv,osx,usx,++isx,ps);
		isx = *ps;
		}
	else    switch(*isx)    {
	case    '#':    if(isspace(isx[1]) || isx[1] == ZERO)
						strcpy(isx,zfn(nv,isx+1));
					else    *osx++ = *isx++;
					continue;
	case    '\t':   if(x[nv].ta)    *osx++ = *isx++;
					else            *isx = ' ';
					continue;
	case	'$':	if(isx[1] == '?')	{
					int		*ad = (int *) NULL;
					char	fs[32];
					varadr(nv,is+2);
					ad = ippop();
					itos(fs,*ad);
					osx = strkat(osx,usx,fs);
					isx += 4;
					}
					else	{
					*osx++ = *isx++;
					}
					continue;
/*VOWELS*/
#ifdef	XASCII
	case    'u':	if(isx[1] == '^')	{
						osx = strkat(osx,usx,vowel[U_HAT]);
						isx += 2;
						}
					else	*osx++ = *isx++;
					continue;
	case    'o':	if(isx[1] == '^')	{
						osx = strkat(osx,usx,vowel[O_HAT]);
						isx += 2;
						}
					else	*osx++ = *isx++;
					continue;
	case    'i':	if(isx[1] == '^')	{
						osx = strkat(osx,usx,vowel[I_HAT]);
						isx += 2;
						}
					else	*osx++ = *isx++;
					continue;
	case    'e':	if(isx[1] == '^')	{
						osx = strkat(osx,usx,vowel[E_HAT]);
						isx += 2;
						}
					else	*osx++ = *isx++;
					continue;
	case    'a':	if(isx[1] == '^')	{
						osx = strkat(osx,usx,vowel[A_HAT]);
						isx += 2;
						}
					else	*osx++ = *isx++;
					continue;
#else	/*XASCII*/
	case    'a':
	case    'e':
	case    'i':
	case    'o':
	case    'u':    if(isx[1] == '^')   {
					*osx++ = VUP;
					*osx++ = '-';
					*osx++ = VDO;
					*osx++ = BSP;
					*osx++ = *isx++;
					isx += 1;
					continue;
					}
#endif	/*XASCII*/
	default:        *osx++ = *isx++;
					continue;
	}
	*osx = ZERO;
	*ps = isx;
	strcpy(is,os);
	return(is);
}
/*
*/
char    *
zesc1(nv,os,us,is,ps)       /* nroff esacaped functions */
char    *os, *us, *is, **ps;
{
	auto    char    *osx = os;
	auto    char    *isx = is;
	auto    char    *usx = us;
	switch(*is) {
		case    ESC:    *osx++ = ESC;
		when    'e':    *osx++ = ESC;
		when    'f':    osx = zesc3(nv,osx,usx,++isx,ps);
						isx = *ps - 1;
		when    '\'':   *osx++ = BSP;
						*osx++ = *isx;
		when    '`':    *osx++ = BSP;
						*osx++ = *isx;
		when	'"':	*osx = ZERO;
						while(*isx != ZERO && *isx != '\n')	++isx;
						if(*isx == '\n')					++isx;
						strcpy(is,isx);
						*ps = is;
						return(osx);
		case    '-':    *osx++ = *isx;
		when    '%':    *osx++ = THP;
		when    '.':    *osx++ = *isx;
		when    ' ':    *osx++ = ZSP;
		when    '0':    *osx++ = ZSP;
		when    '*':    
						osx = zesc2(nv,osx,usx,++isx,ps);
						isx = *ps - 1;
		when    '|':    *osx++ = ZRO;
		when    '^':    *osx++ = ZRO;
		when    '&':    *osx++ = ZRO;
		when    'b':    osx = bracket(nv,osx,usx,++isx,ps);
						isx = *ps - 1;
		when    'c':    *osx++ = ITP;
		when    'd':    *osx++ = VDO;
		when    'h':    osx = lohorz(nv,osx,usx,++isx,ps);
						isx = *ps - 1;
		when    'L':    osx = bldraw(nv,osx,usx,++isx,ps);
						isx = *ps - 1;
		when    'l':    osx = aldraw(nv,osx,usx,++isx,ps);
						isx = *ps - 1;
/*
**  \nX     ?KX
**  \n(XX   ?XX
*/
		when    'n':    if(isx[1] != '(')   {
							*osx++ = '?';
							*osx++ = 'K';
							*osx++ = isx[2];
							isx += 2;
							}
						else    {
							*osx++ = '?';
							*osx++ = isx[3];
							*osx++ = isx[4];
							isx += 3;
							}
		when    'o':    osx = overst(nv,osx,usx,++isx,ps);
						isx = *ps - 1;
		when    'r':    *osx++ = VRV;
		when    't':    *osx++ = '\t';
		when    'u':    *osx++ = VUP;
		when    'v':    osx = lovert(nv,osx,usx,++isx,ps);
						isx = *ps - 1;
		when    'w':    
						osx = width(nv,osx,usx,++isx,ps);
						isx = *ps -1;
		when    'z':    *osx++ = BSP;
						*osx++ = *isx;
						break;
		default:        *osx++ = ESC;
						*osx++ = *isx;
						break;
	}
	*ps = ++isx;
	return(osx);
}
char    *
bracket(nv,os,us,is,ps)
char    *os, *us, *is, **ps;
{
	auto    char    ws[BLKSIZ];
	auto    char    *osx = os;
	auto    char    *isx = is;
	isx = xgnc(ws,ws+BLKSIZ-1,isx+1,*isx);
	*ps = isx;
	return(osx);
}
char    *
zesc2(nv,os,us,is,ps)       /* nroff accents */
char    *os, *us, *is, **ps;
{
	switch(*is) {
	case    ':':    *is = '"';
	case	'"':
	case    '\'':
	case    '`':
	case    '^':
	case    '~':
	case    ',':    
					*os++ = VUP;
					*os++ = *is;
					*os++ = VDO;
					*os++ = BSP;
					break;
	default:        *os++ = ESC;
					*os++ = '*';
					*os++ = *is;
					break;
	}
	*ps = ++is;
	return(os);
}
char    *
zesc3(nv,os,us,is,ps)       /* font changes */
char    *os, *us, *is, **ps;
{
		switch(*is) {
		case    'B':    *os++ = FOB;
						xfont(FOB);
		when    'I':	*os++ = FOI;
						xfont(FOI);
		when    'P':    
						x[nv].cf ^= x[nv].pf;
						x[nv].pf ^= x[nv].cf;
						x[nv].cf ^= x[nv].pf;
						*os++ = x[nv].cf;
		when    'R':    *os++ = FOR;
						xfont(FOR);
		when    'U':    *os++ = FOU;
						xfont(FOU);
						break;
		default:        *os++ = ESC;
						*os++ = 'f';
						*os++ = *is;
						break;
		}
	*ps = ++is;
	return(os);
}
xno(nv,is)          /* footnote style */
char    *is;
{
	switch(*is) {
	case    'E':
	case    'e':    return(x[nv].no = 'e');
	default:
	case    ZERO:
	case    'F':
	case    'f':    return(x[nv].no = 'f');
	}
}
xfn(nv,is)
char    *is;
{
	return(x[nv].fn = setvar(nv,is,ABSO,x[nv].fn,x[nv].fn+1));
}
char	*
zfn(nv,is)          /* foonote register */
char    *is;
{
	static	char	fs[32];
	if(x[nv].fn)    {
		sprintf(fs,"%c%d%c%c",VUP,x[nv].fn,VDO,ZRO);
		x[nv].fn += 1;
		return(fs);
	}
	else    {
		return("");
		}
}
char    *
width(nv,os,us,is,ps)                   /* width function */
char    *os, *us, *is, **ps;
{
	auto    char    ws[BLKSIZ];
	auto    char    xs[BLKSIZ];
	auto    char    *osx = os;
	xs[0] = ws[0] = ZERO;
	is = xgnc(ws,ws+BLKSIZ-1,is+1,*is);
	*ps = ws;
	zesc0(nv,xs,xs+BLKSIZ-1,ws,NOFONT,ps);
	itos(xs,pws(ws));
	osx = strkat(osx,us,xs);
	*ps = is;
	return(osx);
}
char    *
overst(nv,os,us,is,ps)              /* overstrike generator */
char	*os;
char	*us;
char	*is;
char	**ps;
{
/*
**	\o'abc'
*/
	auto	int	cx = *is++;
	while(os < us && *is != ZERO)
	if(*is == cx)	break;
	else			{
		*os++ = *is++;
		if(*is != cx)	*os++ = '\b';
		}
	*os = ZERO;
	*ps = ++is;
	return(os);
}
char    *
bldraw(nv,os,us,is,ps)
char    *os, *us, *is, **ps;
{
	auto    char    ws[BLKSIZ];
	auto    char    xs[BLKSIZ];
	auto    char    *isx = is;
	REG     char    *osx = os;
	REG     int     nsp;
	isx = xgnc(ws,ws+BLKSIZ-1,isx+1,*isx);
	*ps = ws;
	zesc0(nv,xs,xs+BLKSIZ-1,ws,NOFONT,ps);
	nsp = setvar(nv,ws,VERT,0,0);
	if(nsp >= 1)    while(nsp-- >= 1)   {
					*osx++ = DWN;
					*osx++ = isx[-2];
					*osx++ = BSP;
					}
	else
	if(nsp < 0)     nsp = -nsp;
					while(nsp-- >= 1)   {
					*osx++ = isx[-2];
					*osx++ = BSP;
					*osx++ = VRV;
					}
	*ps = isx;
	return(osx);
}
char    *
aldraw(nv,os,us,is,ps)              /* line drawing function */
char    *os, *us, *is, **ps;
{
	auto    char    ws[BLKSIZ];
	auto    char    xs[BLKSIZ];
	auto    char    *isx = is;
	REG     char    *osx = os;
	REG     int     nsp;
	isx = xgnc(ws,ws+BLKSIZ-1,isx+1,*isx);
	*ps = ws;
	zesc0(nv,xs,xs+BLKSIZ-1,ws,NOFONT,ps);
	nsp = setvar(nv,ws,HORZ,0,0);
	if(nsp >= 1)    while(nsp-- >= 1)   *osx++ = isx[-2];
	else
	if(nsp < 0)     while(nsp++ <= 0)   {
					*osx++ = BSP;
					*osx++ = isx[-2];
					*osx++ = BSP;
					}
	*ps = isx;
	return(osx);
}
char    *
lovert(nv,os,us,is,ps)          /* local vertical motion */
char    *os, *us, *is, **ps;
{
	auto    char    ws[BLKSIZ];
	auto    char    xs[BLKSIZ];
	auto    char    *isx = is;
	auto    char    *osx = os;
	REG     int     nsp;
	isx = xgnc(ws,ws+BLKSIZ-1,isx+1,*isx);
	*ps = ws;
	zesc0(nv,xs,xs+BLKSIZ-1,ws,NOFONT,ps);
	nsp = setvar(nv,ws,VERT,0,0);
	if(nsp >= 1)    while(nsp-- >= 1)   *osx++ = DWN;
	else
	if(nsp <= 0)    {
					nsp = -nsp;
					while(nsp-- >= 1)   *osx++ = VRV;
					}
	*osx = ZERO;
	*ps = isx;
	return(osx);
}
char    *
lohorz(nv,os,us,is,ps)          /* local horizontal motion */
char    *os, *us, *is, **ps;
{
	auto    char    ws[BLKSIZ];
	auto    char    xs[BLKSIZ];
	auto    char    *isx = is;
	auto    char    *osx = os;
	REG     int     nsp;
	isx = xgnc(ws,ws+BLKSIZ-1,isx+1,*isx);
	*ps = ws;
	zesc0(nv,xs,xs+BLKSIZ-1,ws,NOFONT,ps);
	nsp = setvar(nv,ws,HORZ,0,0);
	if(nsp >= 1)    while(nsp-- >= 1)   *osx++ = ZSP;
	else            {
					nsp = -nsp;
					while(nsp-- >= 1)   *osx++ = BSP;
					}
	*osx = ZERO;
	*ps = isx;
	return(osx);
}
