/*
	SET BUFFERING FOR A STREAM.  TRY TO GET THE REQUEST AMOUNT
	OTHERWISE AT LEAST BUFSIZ().  CORRECT FOR THE SCREWED UP
	INTERFACE TO SETVBUF IN SOME **IX SYSTEMS.  setvbuf either
	does not work or is defeated by disk chaching in the xenix
	kernel.
*/
/*DOSLIB*/
/*UNXLIB*/
#include	"ksysdefs.h"
#include	"ksysvtyp.h"
#include	"ksysprot.h"
/**/
#ifdef	__TURBOC__
#define	SETVBUF
#endif	/*__TURBOC__*/
/**/
#ifdef	SYSV
#define	SETVBUF
#endif	/*SYSV*/
/**/
#ifdef	SETVBUF
#ifdef	__TURBOC__
#include	<alloc.h>
#endif	/*__TURBOC__*/
/**/
#ifdef	M_XENIX
#define	setzbuf(a,b,c,d)setvbuf(a,c,b,d)
#else	/*M_XENIX*/
#define	setzbuf(a,b,c,d)setvbuf(a,b,c,d)
#endif	/*M_XENIX*/
/**/
char *
ksetvbuf(fp,buf,tbuf,sbuf)
FILE	*fp;	/* STREAM TO BUFFER */
char	*buf;	/* PREVIOUS BUFFER IF ANY */
NOSIGN	tbuf;	/* TYPE */
NOSIGN	sbuf;	/* SIZE IN BYTES */
{
	auto	int		ret;
	auto	NOSIGN	want = sbuf;
	auto	NOSIGN	bsize = bufsiz();
/**/
	fp = fp ? fp : (FILE *) dump("ksetvbuf: fp NULL");
	tbuf = (_IOFBF || _IOFBF || _IONBF) ? tbuf : dump("ksetbuf: tbuf");
/**/
	if(want == 0)	want = sbuf = bufsiz();
	buf = free_if(buf);
	sbuf = (sbuf % bsize == 0) ? sbuf : dump("ksetvbuf: sbuf");
/**/
	while(sbuf >= bsize)	{
		buf = (char *) malloc(sbuf);
		if(buf)	break;
		sbuf -= bsize;
		}
/**/
	if(sbuf < bsize)	{
		errmsg("ksetvbuf <no core for buffer>\n");
		fubar(FUBAR);
		}
	else
	if(sbuf != want)	{
		errmsg("ksetvbuf <reduced buffer> %u -> %u\n",want,sbuf);
		}
	if(setzbuf(fp,buf,tbuf,sbuf))	{
		prterr("<ksetvbuf>");
		dump("ksetvbuf: bad paramenters");
		}
	return(buf);
}
#else	/*SETVBUF*/
char	*
ksetvbuf(fp,buf,ty,si)
FILE	*fp;
char	*buf;
int		ty;
int		si;
{
	if(si == ZERO)	si = bufsiz();
	if(buf == NULL)	buf = malloc(si);
	if(buf == NULL)	{
		errmsg("ksetvbuf <no core> %u\n",si);
		terror(FUBAR);
		}
	setbuffer(fp,buf,si);
	return(buf);
}
#endif	/*SETVBUF*/
