/*COMLIB*/
#include	"ksysdefs.h"
#include	"ksysvtyp.h"
#include	"ksysprot.h"
#include	<time.h>
/*EXTERN*/
extern	void	ktimehint();
/*STATIC*/
#ifdef	CAN_PROTO
static	char	*month(int);
static	char	*weekday(int);
static	void	hint(void);
#else	/*CAN_PROTO*/
static	char	*month();
static	char	*weekday();
static	void	hint();
#endif	/*CAN_PROTO*/
#ifdef  TEST
main()
{
	char    ls[BUFSIZ];
	char    bs[BUFSIZ];
	while(putchar('?'),fflush(stdout),gets(ls))
	switch(ls[0])   {
	case    'q':    exit(0);
	case    'h':    ktimehint();break;
	case    't':    ktime(bs,bs+BUFSIZ-1,ls+1);
					puts(bs);
					break;
	}
}
#endif
char	*
ktime(os,us,is)
char    *os, *us, *is;
{
	register    char    *osx = os;
	register    char    *usx = us;
	register    char    *isx = is;
	long time(),barf;
	struct  tm  *tmx,*localtime();
	time(&barf);
	tmx = localtime(&barf);
	for( ;*isx != ZERO; isx += 1)   {
	if(*isx == '%') switch(*++isx)
	{
	case 's':
		if(tmx->tm_sec <= 9) *osx++ = '0';
		osx = itos(osx,tmx->tm_sec);
		break;
	case 'm':
		if(tmx->tm_min <= 9) *osx++ = '0';
		osx = itos(osx,tmx->tm_min);
		break;
	case 'A':
	case 'P':
		if(tmx->tm_hour >= 12) 
				osx = strkat(osx,usx,"PM");
		else    osx = strkat(osx,usx,"AM");
		break;
	case 'a':
	case 'p':
		if(tmx->tm_hour >= 12) 
				osx = strkat(osx,usx,"pm");
		else    osx = strkat(osx,usx,"am");
		break;
	case 'H':
		if(tmx->tm_hour <= 9) *osx++ = '0';
		osx = itos(osx,tmx->tm_hour);
		break;
	case 'h':
		osx = itos(osx,tmx->tm_hour);
		break;
	case 'd':
		osx = itos(osx,tmx->tm_mday);
		break;
	case 'n':
		osx = itos(osx,tmx->tm_mon+1);
		break;
	case 'M':
		osx = strkat(osx,usx,month(tmx->tm_mon));
		break;
	case 'y':
		osx = itos(osx,tmx->tm_year);
		break;
	case 'Y':
		osx = itos(osx,1900 + tmx->tm_year);
		break;
	case 'W':
		osx = strkat(osx,usx,weekday(tmx->tm_wday));
		break;
	case 'D':
		osx = itos(osx,tmx->tm_yday+1);
		break;
	default:
		*osx++ = '%';
		*osx++ = *isx;
		continue;
	}
	else    {
		*osx++ = *isx;
		}
	}
	*osx = ZERO;
	return(os);
}
static	char	*
month(n)
int n;
{
	static  char    *name[] = {
	"January", "February", "March", "April", "May", "June",
	"July", "August", "September", "October", "November", "December"
	};
	if(n <= 11) return(name[n]);
	else return("");
}
static	char	*
weekday(n)
int n;
{
	static  char    *name[] = {
	"Sunday", "Monday", "Tuesday", "Wednesday",
	"Thursday", "Friday", "Saturday"
	};
	if(n <= 6) return(name[n]);
	else return("");
}
void
ktimehint()
{
	hint();
	return;
}
static void
hint()
{
puts("%s    seconds (00)");
puts("%m    minutes (00)");
puts("%h    hours (0)");
puts("%H    hours (00)");
puts("%p    pm or am");
puts("%P    PM or AM");
puts("%d    day (number)");
puts("%n    month (number)");
puts("%M    month (name)");
puts("%y    year (00)");
puts("%Y    year (0000)");
puts("%W    day (name)");
puts("%ld    year day (number)");
fflush(stdout);
}
