/*
*	this file contains prototypes for most of the functions
*	pertaining to keyio.
*/
typedef int KEYNUM;
#ifdef	CAN_PROTO
extern int cdsize(void);
extern char *cdsv(char *,int);
extern char *cgdk(char *,char *,int);
extern char *cgdp(char *,char *,char *,int,int);
extern char *cgdx(char *,char *,int,int);
extern char *getdol(char *,char *,char *);
extern char *iopull(char *);
extern char *keysget(void);
extern char *lsgdata(char *,int,int,int);
extern char *lsgkey(char *,int,int);
extern char *lsrdcd(char *,int,int);
extern char *rderr(char *);
extern KARD *setkd(char *);
extern char *strglue(int,char *,char *,char *);
extern char *undefined(char *,char *,char *);
extern int badkey(char *);
extern NOSIGN bufferget(NOSIGN);
extern void cdcond(void);
extern int cdprp(KEYNUM,FILE *,NOSIGN,NOSIGN);
extern int cdprpd(KEYNUM,NOSIGN,NOSIGN,FILE *);
extern void cgdb( char *,int);
extern void cgde(char *,char *,int);
extern int cgdt(int,int);
extern int cgdz(int);
extern void clcd(void);
extern int dsub(char *,char *,char *,char *,int,int);
extern void highkey(FILE *,char *);
extern int iskey(char *);
extern int keyscheck(void);
extern void keyslist(void);
extern int keysread(char *);
extern int lsrdfc(int);
extern int nullcd(void);
extern int preh(int);
extern int prex(int);
extern int prpr(int,int);
extern int rdcd(FILE *,NOSIGN);
extern void redraw(char *,int);
extern int suberr(char *,char *,FUNCP);
extern int subparse(char *,FUNCP,char **,int,int *,int *);
extern int thint(int);
extern int twrcd( FILE *,int,int);
extern int twrkey( char *);
extern int twrset(char *);
extern int twrshow(FILE *);
extern int virdcd( FILE *);
extern int wrone(int,int);
extern void xsfwrcd( char *,FILE *,int);
extern int xtocd(char *,NOSIGN);
extern int zpone(int);
extern char *keysfile(char *);
extern int wrcd(FILE *,int,int);
extern void kdovi(int,int,char *);
#else
extern int cdsize();
extern char *cdsv();
extern char *cgdk();
extern char *cgdp();
extern char *cgdx();
extern char *getdol();
extern char *iopull();
extern char *keysget();
extern char *lsgdata();
extern char *lsgkey();
extern char *lsrdcd();
extern char *rderr();
extern KARD *setkd();
extern char *strglue();
extern char *undefined();
extern int badkey();
extern NOSIGN bufferget();
extern void cdcond();
extern int cdprp();
extern int cdprpd();
extern void cgdb();
extern void cgde();
extern int cgdt();
extern int cgdz();
extern void clcd();
extern int dsub();
extern void highkey();
extern int iskey();
extern int keyscheck();
extern void keyslist();
extern int keysread();
extern int lsrdfc();
extern int nullcd();
extern int preh();
extern int prex();
extern int prpr();
extern int rdcd();
extern void redraw();
extern int suberr();
extern int subparse();
extern int thint();
extern int twrcd();
extern int twrkey();
extern int twrset();
extern int twrshow();
extern int virdcd();
extern int wrone();
extern void xsfwrcd();
extern int xtocd();
extern int zpone();
extern char *keysfile();
extern int wrcd();
extern void kdovi();
#endif
