#define			KORDWORK	"/koXXXXXX.tmp"
#define			NOSIGN		unsigned
#define			R_OPEN		1
#define			R_CLOSE		2
#define		SDICT	1
#define		SFOLD	2
#define		SNUMB	4
#define		SREVR	8
#define		SUNIQ	16
#define		SBLNK	32
#define		SARTS	64
#define		SZZZZ	128
#define		STIME	256
#define		SLIMT	512
#define		SWORD	1024
/**/
#define		NSPARTS			10
#define		SORTSEP			'%'
#define		SORTOFF			3			   	/* sort offset */
#define		NSORTS		  	8				/* max sorts */
#define		NLIST		   	16				/* list of fields */
#define		NFILES		  	16				/* max files */
#define		IAM				"kord"
#define		SORTDOS			"sortsort.exe"
#define		SORTUNIX		"sort"
#define		WORKUNIX		"/usr/tmp/koXXXXXX.tmp"
#define		WORKDOS			"c:/koXXXXXX.tmp"
#define		SMLBLK			128
#define		BIGBLK			1024
/**/
/**/
typedef struct	KSORT
{
		char		rc[SMLBLK];		/* raw command */
		char		sc[SMLBLK];		/* sort command */
		int		kl[NLIST];		/* numberical equivalents of keys */
		int		nks;			/* items in above */
		int		opt;			/* options (binary flags) */
		int		lmt;			/* max length */
		int		wds;			/* max words */
}	KSORT;
#ifdef		ALLOCATE
#define		CRAP	/**/
#else
#define		CRAP	extern
#endif
CRAP	KENV	kenv;
CRAP	KSORT	ksx[NSORTS];
CRAP	FILE	*xfp;
CRAP	char	xfn[FNMSIZ];
CRAP	char	*biblsort;				/* sort program name */
CRAP	char	*tmpdir;				/* directory for work files */
CRAP	NOSIGN	first;					/* advertisement switch */
CRAP	NOSIGN	error;					/* error limit */
CRAP	NOSIGN	in_cards;				/* total number of cards input */
CRAP	NOSIGN	ot_cards;				/* total number of cards output */
CRAP	NOSIGN	rd_cards;				/* total number of cards read */
CRAP	int		join;
CRAP	int		nsorts;
CRAP	int		over;
CRAP	int		uniq;
CRAP	FILE	*ofp;					/* output file pointer */
CRAP	char	*ofn;					/* output file */
CRAP	FILE	*wfp;					/* work file pointer */
CRAP	char	wfn[FNMSIZ];			/* work file */
CRAP	FILE	*rfp;					/* read file pointer */
CRAP	FILE	*ifp;					/* input file pointer */
CRAP	char	acmd[BLKSIZ];			/* a filter */
CRAP	char	bcmd[BLKSIZ];			/* b filter */
CRAP	char	ecmd[BLKSIZ];
CRAP	char	ls[BLKSIZ];				/* general line buffer */
CRAP	char	ps[BLKSIZ];				/* prev string for uniq */
CRAP	char	cs[BLKSIZ];				/* current string for uniq */
CRAP	char	*ifn;					/* input file list as string */
CRAP	char	*efn;					/* source (.so) file name */
CRAP	char	sfn[FNMSIZ];			/* sort (index) file */
CRAP	char	sc[BLKSIZ];				/* sort command buffer */
CRAP	char	*scx;
CRAP	char	*scu;
/*KEYIO*/
extern	KBUF	kb;
extern	KARD	*kd;
/*EXTERNAL*/
#ifdef	CAN_PROTO
extern int findsort(char *);
extern char *fexpand(char *);
extern badcard(char *,FILE *,NOSIGN,long);
extern badcmd(char *);
extern canread(char *);
extern cansort();
extern char *dowds(char *,int);
extern char *rderr(char *);
extern char *setcmd(char *,char *);
extern char *sortdate(char *);
extern char *zart(char *);
extern clrsort(char *);
extern dolmt(char *,NOSIGN);
extern dosort(char *,char *);
extern hint(NOSIGN);
extern kord(int,char **);
extern main(int,char **);
extern makework(char *);
extern newdir(char *);
extern newkeys(char *);
extern othercmd(char *,char *);
extern parsecmd(char *,char *);
extern poswfn(FILE *,long,char *);
extern rebuild();
extern setjoin(char *);
extern setsort(char *,char *);
extern tgetcmd(char *,char *,FILE *);
extern touch(char *);
extern void callsort(char *,char *);
extern void cleanup();
extern void doexpr(char *);
extern void doso(char *,char *);
extern void filelist(char *);
extern void listing(char *);
extern void outlist(int,char **);
extern void rcmdlist(int,char **);
extern void setifn(char *);
extern void setofn(char *,char *);
extern void showfile(NOSIGN,char *);
extern void terror(int);
extern void xso(char *);
extern wrsort(FILE *,long);
extern zapsort(char *);
#else
extern char *fexpand();
extern badcard();
extern badcmd();
extern canread();
extern cansort();
extern char *dowds();
extern char *rderr();
extern char *setcmd();
extern char *sortdate();
extern char *zart();
extern clrsort();
extern dolmt();
extern dosort();
extern hint();
extern kord();
extern main();
extern makework();
extern newdir();
extern newkeys();
extern othercmd();
extern parsecmd();
extern poswfn();
extern rebuild();
extern setjoin();
extern setsort();
extern tgetcmd();
extern touch();
extern void callsort();
extern void cleanup();
extern void doexpr();
extern void doso();
extern void filelist();
extern void listing();
extern void outlist();
extern void rcmdlist();
extern void setifn();
extern void setofn();
extern void showfile();
extern void terror();
extern void xso();
extern wrsort();
extern zapsort();
extern int findsort();
#endif
