#include	"ksysdefs.h"
#include	"ksysvtyp.h"
#include	"ksysprot.h"
#include	"kroffdef.h"
#define		__GLOBAL__
#include	"kroffvar.h"
/**/
/**/
#include    <signal.h>
/**/
#ifdef		MSDOS
#include	"ksysgtty.h"
#else
#include    <sgtty.h>
#endif
/**/
/*GLOBAL_BEGIN*/
char    *initial;
char    *o3 = x[2].os;
char    *o2 = x[1].os;
char    *o1 = x[0].os;
/*EXTERNAL*/
extern	FUNCS	ignore();
extern	char	*savecmd();
extern	int		kroff();
/**/
xab(nv,is)              /* terminate violently */
char    *is;
{
	terror(FUBAR);
	return(FUBAR);
}
xex(nv,is)              /* simulate end of text */
char    *is;
{
	xem(nv,(char *) NULL);
	cleanup(0);
	exit(0);
}
cleanup(nr)
{
	xdiz();             /* unlink any diversions */
#ifndef	__TURBOC__
	if(isatty(1))       {
		termset(1,CBREAK,0);
		termset(1,ECHO,1);
		}
#endif	__TURBOC__
	return(nr);
}
main(argc,argv)
int     argc;
char    *argv[];
{
	kenv.dosdos = isdos();
	disnme(kenv.pname = "kroff");
	exit(cmdxrc(argc,argv,kroff,"kroff.xrc"));
}
kroff(argc,argv)
int		argc;
char	*argv[];
{
/**/
	ob = ib = NULL;
/**/
	ls = emalloc(bufsiz(),"main");
/**/
	if(!kenv.dosdos)	telluser(kenv.pname);
	else				cmdxpd(argc,argv);
/**/
	disrec(cmdnum(argc,argv,'R',1,0));
/**/
	if(cmdnum(argc,argv,'h',0,DA))	{
		if(isatty(1))	{
			kenv.leisur = DA | DB;
			whoru(stdout);
			query(stdout);
			}
		khint(kenv.pname,NULL);
		exit(0);
		}
/**/
	options(argc,argv);
/**/
	if(signal(SIGINT,SIG_DFL) != SIG_IGN)	{
#ifdef	MSDOS
		setcbrk(YES);
#else
		signal(SIGPIPE,terror);
		signal(SIGBUS,terror);
		signal(SIGALRM,terror);
#endif
		signal(SIGINT,terror);
		}
/**/
	xflist(argc,argv);
	xdiz();
	exit(0);
}
options(argc,argv)      /* process options */
int     argc;
char    *argv[];
{
	initial = cmdstr(argc,argv,'I',(char *) NULL);
/**/
	if(cmdnum(argc,argv,'O',0,1))	{
		auto	char	*ofn;
		ofn = cmdstr(argc,argv,'O',kgetenv("KROFFOUT"));
		if(!freopen(ofn,"w",stdout))	{
			prterr(ofn);
			exit(FUBAR);
			}
		}
/**/
	if(cmdnum(argc,argv,'o',0,1))   {
		ol = 1;
		mklist(cmdstr(argc,argv,'o',(char *) NULL));
		}
	ra = cmdnum(argc,argv,'r',0,1);                 /* raw output */
	sl = isatty(fileno(stdout)) * 22;
	sl = cmdnum(argc,argv,'s',sl,22);               /* slow output */
	db = cmdnum(argc,argv,'D',0,DA);                /* diagnostics */
	tt = kgetenv("TERM");                           /* term type */
	tt = cmdstr(argc,argv,'T',tt);
#ifdef	DEBUG
	{
	auto	int		i;
	for(i = 1; i < argc; i++)
		if(argv[i])	fprintf(stderr,"%d (%s)\n",i,argv[i]);
	}
	fprintf(stderr,"tt (%s)\n",tt);
	sleep(1);
#endif	DEBUG
	return(ZERO);
}
/**/
void
terror(ty)
int		ty;
{
	auto	char	*msg;
	static	NOSIGN	loop = ZERO;
/**/
	if(loop++ >= FNMSIZ)	exit(FUBAR);
/**/
	if(ty != FUBAR)	signal(ty,SIG_IGN);
/**/
	if(kenv.prompt)	{
		msg = savecmd(NULL);
		if(!isnull(msg))    errmsg("<last command> '%s'\n",msg);
		filewalk();         /* file walkback */
	}
/**/
	cleanup(ty);
/**/
	ttrst(stdout);
/**/
	exit(ty);
}
