/*UNXLIB*/
/*DOSLIB*/
#define	NOTATTY
#define	ABORT
#ifdef	MSDOS
termset(){return(0);}
cbc_on(){return(0);}
cbc_off(){return(0);}
#else
#include	"ksysdefs.h"
#include	"ksysvtyp.h"
#undef		CAN_PROTO
#include	"ksysprot.h"
/**/
#include    <sgtty.h>
/**/
static	int	tset;
/**/
termset(fd,mask,act)    /* set CBREAK, ECHO, etc. */
int		fd;
int		act;
int		mask;
{
	struct  sgttyb  bufa;
/*
**  termset(fd,CBREAK,1)    turns ON CBREAK
**  termset(fd,ECHO,1)      turns ON ECHO
**  termset(fd,CBREAK,0)    turns OFF CBREAK
**  termset(fd,ECHO,0)      turns OFF ECHO
*/
/**/
#ifdef	NOTATTY
	if(!isatty(fd))	return(notatty("termset"));
#endif	NOTATTY
	ioctl(fd,TIOCGETP,&bufa);
/**/
	if(act == YES)  bufa.sg_flags   |= mask;
/**/
	if(act == NO)   bufa.sg_flags   &= ~mask;
/**/
	if(ioctl(fd,TIOCSETP,&bufa) < 0)	{
		prterr("");
		return(-1);
		}
/**/
	if(mask == CBREAK)	tset = act;
	return(fd);
}
notatty(is)
char	*is;
{
	errmsg("%s <not a tty>\n");
#ifdef	ABORT
	fubar(FUBAR);
#endif	ABORT
	return(-1);
}
cbc_off(fd)
NOSIGN	fd;
{
	if(tset)	{
		termset(fd,CBREAK,0);
		termset(fd,ECHO,1);
		}
	return(tset = 0);
}
cbc_on(fd)
NOSIGN	fd;
{
	if(!tset)	{
		termset(fd,CBREAK,1);
		termset(fd,ECHO,0);
		}
	return(tset = DA);
}
#ifdef	TEST
KENV	kenv;
void
terror(ty)
int		ty;
{
	cbc_off(0);
	exit(ty);
}
main()
{
	auto	int		rx;
	auto	char	cx;
	cbc_on(0);
	while(1)	{
		rx = read(0,&cx,sizeof(char));
		write(1,&cx,sizeof(char));
		fprintf(stderr,"rx(%u) cx(%u)\n",rx,cx);
		fputc('[',stderr);
		fputc(cx,stderr);
		fputc(']',stderr);
		fputc('\n',stderr);
			}
	cbc_off(0);
}
#endif	/*TEST*/
#endif
