/*DOSLIB*/
/*UNXLIB*/
#include        <stdio.h>
#include        <ctype.h>
#define         BIG_BULL                10240
/**/
#define         ksetvbuf(a,b,c,d)setvbuf(a,b,c,d)
#ifdef  __TURBOC__
#define CAN_PROTO
#undef          ksetvbuf
#define         ksetvbuf(a,b,c,d)setvbuf(a,b,c,d)
#endif
#ifdef  M_XENIX
#undef          ksetvbuf
#define         ksetvbuf(a,b,c,d)setvbuf(a,c,b,d)
#define CAN_PROTO
#endif
/**/
#include        <sys/types.h>
#include        <sys/stat.h>
/**/
#define         AMASK   0177
#define         NO              0
#define         YES             1
#define         FUBAR   69
#define         LF              '\n'
#define         CR              '\r'
#undef          NULLC
#define         NULLC   'z'                                     /* NULL as char */
#define         FUDGE   32
#define         BSIZE   5
#define         BASE    85L
#define         FOLD    75                                      /* n * BSIZE */
typedef unsigned long LBUF;
typedef unsigned int NOSIGN;
static          long    percent;                        /* percent of file processed */
static          long    totalsize;                      /* total file size */
static          long    codedsize;                      /* total size coded */
static          long    period = 10;            /* nap at end of lines */
static          long    report = 100;           /* report every nn lines */
static          long    linesi;                         /* lines in count */
static          long    check;                          /* check sum */
static          long    base = BASE;            /* conversion base */
static          short   fw = FOLD;                      /* fold point */
static          LBUF    lbuf;                           /* 4-byte word */
static          char    zbuf[4];
static          char    sbuf[BSIZE];            /* encoded word */
static          int             (*func)();                      /* encode or decode */
static          int             fset;                           /* function set */
static          char    *tmpdir;                        /* temp dir for work */
static          char    ls[BUFSIZ];                     /* line buffer */
static          char    *ofb;
static          char    *ifb;
#ifdef  MSDOS
static          char    *rmode = "rb";
static          char    *wmode = "wb";
#else
static          char    *rmode = "r";
static          char    *wmode = "w";
#endif
/*EXTERN*/
#ifdef  CAN_PROTO
extern char * fgets(char *,int,FILE *);
extern char *getenv(char *);
extern char *malloc(unsigned);
extern char *strcpy(char *, char *);
extern int atoi(char *);
extern long atol(char *);
extern int decode(char *);
extern int encode(char *);
extern void exit(int);
extern long filesize(char *);
extern int hint(FILE *);
extern int isatty(int);
extern int setcmd(int,char **);
extern int setopt(int,char **);
extern int stat(char *, struct stat *);
extern int strlen(char *);
extern int strncmp(char *, char *, int);
#else
extern char * fgets();
extern char *getenv();
extern char *malloc();
extern char *strcpy();
extern int atoi();
extern long atol();
extern int decode();
extern int encode();
extern void exit();
extern long filesize();
extern int hint();
extern int isatty();
extern int setcmd();
extern int setopt();
extern int stat();
extern int strlen();
extern int strncmp();
#endif
/**/
long
filesize(is)
char    *is;
{
        struct  stat    sb;
        if(stat(is,&sb))        return(-1L);
        else                            return(sb.st_size);
}
main(argc,argv)
int             argc;
char    *argv[];
{
/**/
        if(sizeof(long) != 4)   {
                fprintf(stderr,
                        "<hardware problems: size of long> '%u'\n",
                                sizeof(long));
                exit(FUBAR);
                }
/**/
        setbuf(stderr,malloc(BUFSIZ));
#ifdef	SYSV
        ksetvbuf(stdout,ofb,_IOFBF,BIG_BULL);
        ksetvbuf(stdin,ifb,_IOFBF,BIG_BULL);
#endif	/*SYSV*/
/**/
        tmpdir = getenv("TMPDIR");
        if(tmpdir)      {
                tmpdir = malloc( strlen(tmpdir) + 1 );
                strcpy(tmpdir,getenv("TMPDIR"));
                }
/**/
        setopt(argc,argv);
        setcmd(argc,argv);
        exit(0);
}
static  char    *usage[] = {
        "==========",
        "kencode [-options] [file]",
        "==========",
        "*",
        "*       code arbitary input to printable ascci",
        "*",
        "==========",
        "-e      encode",
        "-d      decode",
#ifdef  X86
        "-nNNN   nap NNN milliseconds [10] at the end of each line",
        "        for slow links (encode only)",
#endif
        "-o file write output to file",
        "-rNNN   report every NNN lines [100] processed",
        "==========",
        NULL,
        }       ;
hint(fp)
FILE    *fp;
{
        auto    char    **use = usage;
        while(*use)     {
                fputs(*use++,fp);
                fputs("\n",fp);
                }
        fflush(fp);
        if(fp == stderr)        exit(FUBAR);
        else
        if(fp == stdout)        exit(0);
}
setcmd(argc,argv)
int             argc;
char    *argv[];
{
        auto    int             ix;
        auto    int             fc = 0;
        for(ix = 1; fc == 0 &&  ix < argc; ix++)        {
        if(argv[ix])    {
                (*func)(argv[ix]);
                fc += 1;
                }
        }
        if(fc == 0)     (*func)(NULL);
        return;
}
setopt(argc,argv)
int             argc;
char    *argv[];
{
        auto    int             ix;
        auto    char    *ps;
        fset = 0;
        for(ix = 1; ix < argc; ix++)    {
        if(argv[ix] == NULL)                    continue;
        ps = argv[ix];
        if(*ps != '-')                                  continue;
        while(ps && *ps)        switch(*ps++)   {
                case    '-':    break;
                case    'o':    argv[ix] = NULL;
                                                ps = argv[++ix];
                                                if(!(freopen(ps,wmode,stdout))) {
                                                        fprintf(stderr, "<open error> %s %s\n",wmode,ps);
                                                        exit(FUBAR);
                                                        }
                                                ps = NULL;
#ifdef	SYSV
                                                ksetvbuf(stdout,ofb,_IOFBF,BIG_BULL);
#endif	/*SYSV*/
                                                break;
                case    'e':    func = encode;
                                                fset += 1;
                                                break;
                case    'd':    func = decode;
                                                fset += 1;
                                                break;
                case    'n':    period = atoi(ps);
                                                while(isdigit(*ps))     ++ps;
                                                break;
                case    'r':    report = atoi(ps);
                                                while(isdigit(*ps))     ++ps;
                                                break;
                default:                hint(stderr);
                                                break;
                case    '?':
                case    'H':
                case    'h':    
                                                hint(stdout);
                                                break;
                }
        argv[ix] = NULL;
        }
/**/
        if(fset == 0 || fset > 1) hint(stderr);
/**/
        return;
}
decode(is)
char    *is;
{
        auto    short   ix;
        auto    short   fw = FOLD;
        auto    NOSIGN  cx;
        auto    long    wreck;
        auto    int             headtry = 5;
        auto    long    beg;
        auto    long    cur;
        auto    long    tcc;
        tcc = 0L;
        time(&beg);
        if(is)  {
                if(!(freopen(is,rmode,stdin)))  {
                        fprintf(stderr,"kencode <cannot open file> %s for %s\n",is,rmode);
                        exit(FUBAR);
                        }
#ifdef	SYSV
                ksetvbuf(stdin,ifb,_IOFBF,BIG_BULL);
#endif	/*SYSV*/
                }
        else    is = "-";
/**/
        while(headtry-- >= 1)   {
                fgets(ls,BUFSIZ-1,stdin);
#ifdef  DEBUG
        {
        fputs(ls,stderr);
        fputs("\n",stderr);
        }
#endif
                if(strncmp(ls,"headof ",7) == 0)        break;
                }
/**/
        if(headtry <= 0)        {
                fprintf(stderr,"kencode <could not find header>\n");
                exit(FUBAR);
                }
/**/
        linesi = check = 0L;
/**/
        while(fgets(ls,BUFSIZ-1,stdin))         {
                tcc += (strlen(ls) + 1);
                if(report && (linesi++ % report == 0))  {
                        time(&cur);
                        cur -= beg;
                        cur = (cur >= 1L) ? cur : 1;
                        cur = tcc / cur;
                        fprintf(stderr,"%6ld ",linesi);
                        fprintf(stderr,"%6ld\r",cur);
                        fflush(stderr);
                        }
                if(ls[0] == 't' && strncmp(ls,"tailof",6) == 0) break;
                fw = 0;
                while(ls[fw] != LF && fw < FOLD)        {
                        lbuf = 0L;
                        for(ix = 0; ix < BSIZE; ix++,fw++)      {
                                cx = ls[fw];
                                check += cx;
#ifdef  NULLC
                                cx = cx == NULLC ? ' ' : cx;
#endif
                                cx -= FUDGE;
                                lbuf = base * lbuf + cx;
                                }
#ifdef  SUN
                        swrite( (char *) &lbuf, sizeof(long), 1, stdout);
#else
                        fwrite( (char *) &lbuf, sizeof(long), 1, stdout);
#endif
                        }
        }
/**/
        wreck = atol(ls + strlen("tailof "));
        if(wreck != check)      {
                fprintf(stderr,"kencode <checksum error> %s\n",is);
                exit(FUBAR);
                }
/**/
        return(0);
}
#ifdef  SUN
swrite(os,ne,wi,fp)
char    *os;
int             ne;
int             wi;
FILE    *fp;
{
        register        int             ix = ne * wi - 1;
        while(ix >= 0)  putc(os[ix--],fp);
        return(0);
}
#endif
encode(is)
char    *is;
{
        auto    char    *zs;
        auto    short   ix;
        auto    NOSIGN  cx;
        auto    int             nci;
        auto    long    tot = 0L;
        auto    NOSIGN  delay = NO;
/**/
        codedsize = totalsize = 0L;
/**/
        if(is)  {
                if(!(freopen(is,rmode,stdin)))  {
                        fprintf(stderr,"kencode <cannot open file> %s for %s\n",is,rmode);
                        exit(FUBAR);
                        }
#ifdef	SYSV
                ksetvbuf(stdin,ifb,_IOFBF,BIG_BULL);
#endif	/*SYSV*/
                totalsize = filesize(is);
                }
        else    is = "-";
/*
        if writing to a terminal and delay has not been turned off,
        turn on delay switch
*/
        if(period && isatty(fileno(stdout)))    {
                delay = YES;
                fprintf(stderr,"kencode <delaying each line> %ld milliseconds\n",
                        period);
                fflush(stderr);
                }
/**/
        fw = FOLD;
        printf("headof %s\n",is);
        linesi = check = 0L;
/*
        note the reversed size_item, num_item here.  lbuf is actually
        used as a charcter buffer.  thus the size of each element is
        actually 1 byte.
*/
#ifdef  SUN
        while((int) (nci = fread( zbuf, 1, sizeof(long) , stdin)))      {
                zs = (char *) &lbuf;
                zs[3] = zbuf[0];
                zs[2] = zbuf[1];
                zs[1] = zbuf[2];
                zs[0] = zbuf[3];
#else
        while(nci = (int) fread( (char *) &lbuf, 1, sizeof(long) , stdin))      {
#endif
                tot += nci;
                codedsize += nci;
                if(fw <= 0)     {
                        fw = FOLD;
                        putchar(LF);
#ifdef  X86
                        if(delay)       nap(period);
#endif
                        if(report && (linesi++ % report == 0))  {
                                percent = 0;
                                if(totalsize >= 1L)     {
                                        percent = (codedsize * 100L) / totalsize;
                                        }
                                fprintf(stderr,"%6ld %5ld%%\r",linesi,percent);
                                fflush(stderr);
                                }
                        }
                for(ix = 0; ix < BSIZE; ix++)           {
                        cx = lbuf % base;
                        lbuf /= base;
                        cx += FUDGE;
#ifdef  NULLC
                        cx = cx == ' ' ? NULLC : cx;
#endif
                        check += cx;
                        sbuf[ix] = cx;
                        }
                for(ix = BSIZE - 1; ix >= 0; ix--)      {
                        putchar(sbuf[ix]);
                        }
                fw -= BSIZE;
                }
        if(fw)  putchar(LF);
        printf("tailof %ld %s\n",check,is);
        return(0);
}
#ifdef  AMASK
char    *
fgets(os,ns,fp)
char    *os;
int             ns;
FILE    *fp;
{
        register        int             cx;
        register        char    *osx = os;
        auto            char    *usx = os + ns;
        while(osx < usx && (cx = getc(fp)) != EOF)      {
                cx &= AMASK;
                if(cx == CR)    continue;
                *osx++ = cx;
                if(cx == LF)    break;
                }
/**/
        *osx = 0;
/**/
        return( (cx == EOF) ? NULL : osx );
}
#endif
